/* see setpe.c for copyright info */

/**************************************************
 * Author: Moreno 'baro' Baricevic                *
 * Date:   08 Feb 2005                            *
 * Title:  setpe.h                                *
 *================================================*
 * Last Modified: 08 Feb 2005                     *
 **************************************************/


#ifndef _SETPE_H_
#define _SETPE_H_


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/time.h>

#include <sys/errno.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include <linux/hpcctl.h>

#include "checkip.h"

#define NET_TO_IP(t)	(((struct sockaddr_in *) &(t).saddr)->sin_addr.s_addr)

#define ERR_OK		  0
#define ERR_PROG	  1
#define ERR_PROG_PID	  3
#define ERR_OTHER	102

#define GATEWAYS_FILENAME	"/proc/hpc/admin/gateways"
#define CONFIG_FILENAME		"/proc/hpc/admin/config"
#define MOSPE_FILENAME		"/proc/hpc/admin/mospe"


extern struct mosixnet mosnet[MAX_MOSNET_ENTS+1];
extern char * pname;
extern int proc_mosix_admin_config_fd;
extern int proc_mosix_admin_mospe_fd;
extern char check;
extern char two_phase;


extern int table_read( int * pe , int * pe_ready , int * nents , struct mosixnet * mosnet_pt );
extern int write_file( int pe , struct mosixnet * table , int nent );

extern int ip_need_two_phase( int pe , int nents , int oldpe , struct mosixnet * oldmosnet , int oldnents );
extern void ip_check_table( int n , int pe );
extern void ip_setpe( int pe , FILE * table );
extern void ip_display( int nents , FILE * table );

extern void setpe_off( void );
extern void setpe_read( FILE * table );
extern void setpe_write( FILE * table , int pe , int net_type );

extern void set_gateways( int gateways );


#endif /* _SETPE_H_ */




/***********************  E N D   O F   F I L E  ************************/

